
Redmine - Feature #25999

View repository content by default (instead of the history)

2017-05-18 12:30 - Jan from Planio www.plan.io

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: UI Estimated time: 0.00 hour

Target version: 3.4.0   

Resolution: Fixed   

Description

In line with the changes proposed in #25988, I'd like to propose to change the default behaviour for clicking on entries in the

repository to showing the entry's contents, rather than it's history. The research we did at Planio showed that viewing is the more

common action. GitHub and Bitbucket use the same behaviour, by the way.

This patch series also introduces the existing 2nd level tab style for the "View", "History", and "Annotate" links on repo entries and

adds the download icon introduced in #25988 to the download links to make them a little more prominent.

Here's a screenshot:

 repo_entries_tabs.png 

Related issues:

Related to Redmine - Feature #25357: "Raw view" of a file in repository New

Related to Redmine - Feature #14332: [Repository] Make "view file" the default Closed

Blocks Redmine - Feature #26035: More visually consistent download links Closed

Associated revisions

Revision 16646 - 2017-06-10 10:40 - Jean-Philippe Lang

View content of repository files by default, instead of its history (#25999).

Patch by Jan Schulz-Hofen.

Revision 16647 - 2017-06-10 10:41 - Jean-Philippe Lang

Add download icon to download links on file and repo entry preview (#25999).

Patch by Jan Schulz-Hofen.

Revision 16648 - 2017-06-10 10:41 - Jean-Philippe Lang

Make common/_tabs partial usable without JS partial switching (#25999).

Patch by Jan Schulz-Hofen.

Revision 16649 - 2017-06-10 10:42 - Jean-Philippe Lang

Style links on repository entries as 2nd level tabs (like in settings) (#25999).

Patch by Jan Schulz-Hofen.

Revision 16650 - 2017-06-10 10:50 - Jean-Philippe Lang

Adds missing .icon-download CSS class (#25999).

History

#1 - 2017-05-18 12:30 - Jan from Planio www.plan.io

- Blocked by Feature #25988: Preview files by default instead of downloading them added

#2 - 2017-05-18 12:31 - Jan from Planio www.plan.io

- Description updated
#3 - 2017-05-19 04:12 - Go MAEDA

Jan from Planio www.plan.io wrote:

I'd like to propose to change the default behaviour for clicking on entries in the repository to showing the entry's contents, rather than it's history.

The research we did at Planio showed that viewing is the more common action.

 Absolutely agree. To be honest, it was frustrating for me to click a lot to see source codes. I am sure that the patch can greatly improves UX of

Redmine.

#4 - 2017-05-19 04:17 - Go MAEDA

- File repo-browser-breadcrumbs@2x.png added

I think it would be even better to change link destination of the breadcrumbs too.

diff --git a/app/views/repositories/_breadcrumbs.html.erb b/app/views/repositories/_breadcrumbs.html.erb

index eb115f9ad..82f25d43a 100644

--- a/app/views/repositories/_breadcrumbs.html.erb

+++ b/app/views/repositories/_breadcrumbs.html.erb

@@ -18,7 +18,7 @@ dirs.each do |dir|

 <% end %>

 <% if filename %>

     / <%= link_to filename,

-                   :action => 'changes', :id => @project, :repository_id => @repository.identifier_param,

+                   :action => 'entry', :id => @project, :repository_id => @repository.identifier_param,

                    :path => to_path_param("#{link_path}/#{filename}"), :rev => @rev %>

 <% end %>

 <%

  

#5 - 2017-05-19 06:36 - Marius BĂLTEANU

+1 Nice improvement.

#6 - 2017-05-19 07:50 - Go MAEDA

- Related to Feature #25357: "Raw view" of a file in repository added

#7 - 2017-05-20 02:52 - Go MAEDA

- Related to Feature #14332: [Repository] Make "view file" the default added

#8 - 2017-05-21 08:30 - Go MAEDA

- Target version changed from Candidate for next minor release to 3.4.0

This is a great improvement. Setting target version to 3.4.0.

#9 - 2017-05-21 10:07 - Jan from Planio www.plan.io
Go MAEDA wrote:

I think it would be even better to change link destination of the breadcrumbs too.

 Thank you for improving my patch! I totally agree.

#10 - 2017-05-24 17:27 - Jan from Planio www.plan.io

- File deleted (0001-Make-View-the-default-action-for-repository-entries-.patch)

#11 - 2017-05-24 17:27 - Jan from Planio www.plan.io

- File 0001-Make-View-the-default-action-for-repository-entries-.patch added

Please find attached updated patch 0001. It now contains the changes suggested by Go.

#12 - 2017-05-26 10:25 - Jan from Planio www.plan.io

- Blocks Feature #26035: More visually consistent download links added

#13 - 2017-06-02 00:02 - Mischa The Evil

Jan from Planio www.plan.io wrote:

In line with the changes proposed in #25988, I'd like to propose to change the default behaviour for clicking on entries in the repository to

showing the entry's contents, rather than it's history. The research we did at Planio showed that viewing is the more common action. GitHub and

Bitbucket use the same behaviour, by the way.

 I agree. This could really reduce the required number of clicks to get to the content (which is IMHO indeed a valid drawback of the current

implementation).

#14 - 2017-06-10 10:51 - Jean-Philippe Lang

- Blocked by deleted (Feature #25988: Preview files by default instead of downloading them)

#15 - 2017-06-10 10:52 - Jean-Philippe Lang

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Patches are committed, thanks.

Files

repo_entries_tabs.png 122 KB 2017-05-18 Jan from Planio www.plan.io

0002-Add-download-icon-to-download-links-on-file-and-repo.patch 1.79 KB 2017-05-18 Jan from Planio www.plan.io

0003-Make-common-_tabs-partial-usable-without-JS-partial-.patch 1.55 KB 2017-05-18 Jan from Planio www.plan.io

0004-Style-links-on-repository-entries-as-2nd-level-tabs-.patch 2.95 KB 2017-05-18 Jan from Planio www.plan.io

repo-browser-breadcrumbs@2x.png 30.7 KB 2017-05-19 Go MAEDA

0001-Make-View-the-default-action-for-repository-entries-.patch 3.43 KB 2017-05-24 Jan from Planio www.plan.io
